# gphoto2-library.h File Reference

Camery driver header. More...

`#include <gphoto2/gphoto2-abilities-list.h>`
`#include <gphoto2/gphoto2-camera.h>`

Go to the source code of this file.

## Typedefs

typedef int(*) | CameraLibraryIdFunc (CameraText *id)
| Returns a unique id for the camera driver.
typedef int(*) | CameraLibraryAbilitiesFunc (CameraAbilitiesList *list)
| Adds the abilities of the supported models to the supplied list.
typedef int(*) | CameraLibraryInitFunc (Camera *camera, GPContext *context)
| Initializes the camera.

## Functions

int | camera_id (CameraText *id)
| Get a unique camera id.
int | camera_abilities (CameraAbilitiesList *list)
| Get a list of abilities of all supported cameras.
int | camera_init (Camera *camera, GPContext *context)

## Detailed Description

Camery driver header.

Author:
  Copyright 2000 Scott Fritzinger

Note:
  This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public License along with this library; if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

## Typedef Documentation

typedef int(* ) CameraLibraryAbilitiesFunc(CameraAbilitiesList *list)

Adds the abilities of the supported models to the supplied list.

Parameters:

  | list | a CameraAbilitiesList

Returns:
  a gphoto2 error code

typedef int(* ) CameraLibraryIdFunc(CameraText *id)

Returns a unique id for the camera driver.

Parameters:

  | id | a CameraText

Returns:
  a gphoto2 error code

typedef int(* ) CameraLibraryInitFunc(Camera *camera, GPContext *context)

Initializes the camera.

Parameters:

  | camera | a Camera
  | context | a GPContext

Returns:
  a gphoto2 error code

The camera driver will establish a first connection to the camera and configure the camera variable (i.e. using gp_filesystem_set_list_funcs or gp_port_get_settings).

## Function Documentation

int camera_abilities | ( | CameraAbilitiesList * | list | ) |

Get a list of abilities of all supported cameras.

Fill list with abilities of the cameras supported by this camlib.

For each camera, fill a CameraAbilities structure with data about that camera and append it to the list.

The job of this function is basically to extract data from a camlib specific database and insert it into the libgphoto2 camera database. Due to redundant data and other issues, we may decide to revise that database mechanism and replace it by something more flexible and efficient.

This is a camlib API function.

int camera_id | ( | CameraText * | id | ) |

Get a unique camera id.

Set library ID string.

Probably redundant and to be removed shortly, being replaced by the libtool module name defined in the build system.

This is a camlib API function.

int camera_init | ( | Camera * | camera,
|  | GPContext * | context |
| ) |  |  |

Initialize a Camera object.

Sets up all the proper object function pointers, initialize camlib internal data structures, and probably establish a connection to the camera.

This is a camlib API function.